非常非常非常有意思的一道题,正好写一下做题思路
对于到不了的情况,那就是存在连续>0的区间,该区间和>=m,这样不管怎么补血一定过不去,cin的时候,就可以判断
最开始我以为是贪心,发现当前区间走不过去那就返回上一个0点补血,但就是过不去
突然我发现这个样例很有意思
11 7
0 1 0 1 1 1 0 1 1 1 0
按照我一开始想的贪心,在走最后那段111,是回倒数第二个0补血,这样补血是+4,可正确的做法是回正数第二个补血,这样只需要回+1,这就可以看出,纯贪心回上一个0补血是存在漏洞的
那该怎么确定回哪个0补血呢???
这里很容易想到,那肯定是越靠前的0补血越好啊,因为这样可以省去中间一些1回血加的时间
到这里问题就转化为,怎么确定哪个0可以补血
这里反而用到了贪心,就是前面说的,越靠前补血越好,也就是找左边第一个能补血的0点
用前缀和算区间扣血数,二分查找,当前行,那就往左找,当前不行那就往右找
二分 + 前缀和还是很常用的
具体的直接看代码就行
// Problem: 阿里马马与四十大盗
// Contest: NowCoder
// URL: https://ac.nowcoder.com/acm/contest/72980/D
// Memory Limit: 524288 MB
// Time Limit: 2000 ms
// Date: 2024-03-03 09:58:36
//
// Powered by CP Editor (https://cpeditor.org)#include<bits/stdc++.h>
#include<unordered_map>
#define endl '\n'
#define int int64_t
using namespace std;
int a[100005],s[100005],rec[100005],cnt,n,m;
int check(int si) {//找到第一个 si - m < spos的点int l = 1, r = cnt,ans;while (l <= r) {int mid = l + r >> 1;if (si - m >= s[rec[mid]]) l = mid + 1;else ans = mid ,r = mid - 1;}return rec[ans];
}
void solve() {cin >> n >> m;for (int i = 1,sum = 0; i <= n; ++i) {cin >> a[i];if (a[i]) {sum += a[i];if (sum >= m) {cout << "NO\n";return;}}else sum = 0;s[i] = s[i - 1] + a[i];}map<int,int>p;p[1] = m;//当前血量rec[++cnt] = 1;int tot = 0;//sum是扣除血量的总和for (int i = 2,sum = 0; i < n;++i) {if (a[i] == 0) {p[i] = m - sum;rec[++cnt] = i;}sum += a[i];if (sum >= m) {//找补血点,贪心就是贪,最好要从最远点开始补血,越远越好//怎么判断这个补血点行不行呢??//s[i] - s[pos] < mint pos = check(s[i]);tot += m - p[pos];sum = 0;i = pos;}/*cout << "sum = " << sum << endl;cout << "tot = " << tot << endl;*/}cout << tot + n - 1 << endl;
}
signed main() {ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);int t = 1;while (t--) {solve();}return 0;
}